/*
FILE: threads_PF.c
COPYRIGHT (C) 2008    Claudio Aciti (caciti@exa.unicen.edu.ar)
This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU Lesser General Public License as published
   by the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public License
   along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
   USA.
*/

#include <linux/module.h>
#include <asm/io.h>
#include <rtai.h>
#include <rtai_sched.h>

/*definicion del periodo del temporizador en nanosegundos*/
#define TIMERTICKS 100000000


/*definicion del modo de operacion del reloj. Puede ser ONE_SHOT o PERIODIC_MODE*/

#define ONE_SHOT 


/*declaracion de las tareas*/
static RT_TASK Task1;
static RT_TASK Task2;

static void T1(int t)
{

 while (1) {
   
  printk("Tiempo "); 
   /*Se suspende hasta el proximo periodo*/
   rt_task_wait_period();
   }
}


static void T2(int t)
{
while(1) {
  printk("Real\n"); 
   /*Se suspende hasta el proximo periodo*/
   rt_task_wait_period();
}
}

int init_module(void)
{
      RTIME tick_period;
      RTIME now;

rt_task_init(&Task1, T1, 0, 2000, 0, 0, 0);
rt_task_init(&Task2, T2, 0, 2000, 0, 0, 0);

#ifdef ONE_SHOT
rt_set_oneshot_mode();
#endif

tick_period = 4*start_rt_timer(nano2count(TIMERTICKS));

now = rt_get_time();
/*puntero a la estructura, inicio, periodo*/ 
rt_task_make_periodic(&Task1, now + tick_period, 
                                          tick_period);
rt_task_make_periodic(&Task2, now + tick_period,
                                           tick_period);
return 0;
}

void cleanup_module(void)
{
 int cpuid;
 stop_rt_timer();
 rt_busy_sleep(10000000);
 rt_task_delete(&Task1);
 rt_task_delete(&Task2);
}


